/***************************************************************************
                          kbubblesCreateLevel.h  -  description
                             -------------------
    begin                : Mon Jan 10 2000
    copyright            : (C) 2000 by Tony Bjrkenius
    email                : tony.bjorkenius@linux.nu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBUBBLESCREATELEVEL_H
#define KBUBBLESCREATELEVEL_H

#include <qwidget.h>
#include <kapp.h>

#include "global.h"

class QwImageSpriteField;
class QwSpriteFieldView;
class QwSpritePixmapSequence;
class Bubble;
//class QMessageBox;


class kbubblesCreateLevel : public QWidget
{
    Q_OBJECT
	public:
		kbubblesCreateLevel(QWidget* parent, const char *name);
		~kbubblesCreateLevel();
  	QwImageSpriteField *KbField;
  	QwSpritePixmapSequence *KbPixSeq;
	protected:
    void keyReleaseEvent(QKeyEvent *key);
  signals:
  	void done();
  private:
		void setBackgroundImg();
		void toggle_help_widget();
    void create_pixmap(QPixmap &pix, int color );
  	void move_bubble(int x, int y);
  	void next_color();
  	void add_sprite();
  	void load_next_frame();
  	void load_prev_frame();
  	void insert_frame();
  	void delete_frame();
  	void clear_bubbles();
  	void save_levels();
  	void load_levels();
  	void reload_values();
  	void clear_up_and_exit();	
  	QString *levelName;

		Bubble *bubble;
  	QwSpriteFieldView *KbView;
//  	QMessageBox *msgBox;
  	QWidget *msgBox;
		
		struct link_level *lvls;
		int num_sprites;
};

#endif
